﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;

namespace ejGridASPCore.Controllers
{
    public partial class HomeController : Controller
    {
        public IActionResult Index()
        {
            if (order.Count() == 0)
                BindDataSource();
            ViewBag.data = order;
            return View();
        }
        public static List<Orders> order = new List<Orders>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 0, 2.3 * i, new DateTime(1991, 05, 15), "Berlin"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester"));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long ID, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string AdresseTyp)
            {
                this.ID = ID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.AdresseTyp = AdresseTyp;
            }
            
            public long ID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string AdresseTyp { get; set; }
        }
        public ActionResult AdrTypDataAll([FromBody]DataManager dm)
        {
            IEnumerable DataSource = order;
            DataOperations ds = new DataOperations();
            int count = DataSource.Cast<Orders>().ToList().Count();//count
            if (dm.Skip != null)
                DataSource = ds.PerformSkip(DataSource, dm.Skip);
            if (dm.Take != null)
                DataSource = ds.PerformTake(DataSource, dm.Take);
            return Json(new { result = DataSource, count=count });
        }
        public ActionResult CellEditUpdate([FromBody]CRUDModel<Orders> value)
        {
            var ord = value.Value;
            Orders val = order.Where(or => or.ID == ord.ID).FirstOrDefault();
            val.ID = ord.ID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.Freight = ord.Freight;
            val.OrderDate = ord.OrderDate;
            val.AdresseTyp = ord.AdresseTyp;

            return Json(value.Value);
        }
        public ActionResult CellEditInsert([FromBody]CRUDModel<Orders> value)
        {
            value.Value.ID = order.LastOrDefault().ID + 1;
            order.Insert(0, value.Value);
            return Json(value.Value);
        }
        public ActionResult CellEditDelete([FromBody]CRUDModel<Orders> value)
        {
            order.Remove(order.Where(or => or.ID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }

    }
}
